/**
 * Created by zack on 2017/5/18.
 */
(function ($) {
    var onMessage = function (e) {
        var qqLoginResult = FR.jsonDecode(e.data);
        var uid = qqLoginResult.uid;
        var username = qqLoginResult.username;
        var password = qqLoginResult.password;
        if (uid > 0) {
            $('.qq-dialog-close').trigger('click');
            FS.Tools.bbsUcsynLogin(uid, username, password, function (result) {
                $('.sync-log').remove();
                $('body').append('<div class="sync-log">' + result + '</div>');
                _popSmsData();
            }, 'qq');
        }
    };
    if (window.addEventListener) {  // all browsers except IE before version 9
        window.addEventListener("message", onMessage, false);
    } else {
        if (window.attachEvent) {   // IE before version 9
            window.attachEvent("onmessage", onMessage);
        }
    }


    _popSmsData = function (config) {
        FS.SYSMGR.isSMSFuncSupport = true;
        var smsAttr = config || FS.Sync.ajax({
                url: FR.servletURL + '?op=fs_sms&cmd=sms_config_get',
                type: 'POST',
                data: {
                    serverID: FS.serverID
                }
            });
        var smsButton = FS.SYSMGR.tabPane.getWidgetByName("sms");
        FS.SYSMGR.isSMSFuncSupport = smsAttr.isSMSFuncSupport;
        if (smsAttr.isSMSOpen) {
            FS.SYSMGR.username = smsAttr.username;
            smsButton.setValue(smsAttr.isSMSOpen);
            if (FS.SYSMGR.username) {
                FS.SYSMGR.tabPane.getWidgetByName('sms_username').setValue(FS.SYSMGR.username, false);
                FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([2, 3, 4, 5, 6], true);
            } else {
                FS.SYSMGR.tabPane.getWidgetByName('sms_username').setValue(FR.i18nText("Fine-Engine_Plugin_Store_Not_Login"), false);
                FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([2, 3, 4, 5, 6], false);
            }
            if (smsAttr.status !== 'success') {
                FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([2, 3, 4, 5, 6], false);
                FS.SYSMGR.tabPane.getWidgetByName("smsSetPanel").setRowVisible([2, 3, 4], false);
                _create404Div();
                return;
            }
            $('.fs-connect-error').remove();
            //FS.SYSMGR.setWidgetValue("accountType", smsAttr.accountType);
            FS.SYSMGR.setWidgetValue("remain", smsAttr.testRemain);
            FS.SYSMGR.setWidgetValue("signature", FR.i18nText("FS-SMS_Signature_Message_Platform"));
            FS.SYSMGR.setWidgetValue("balance", smsAttr.balance + FR.i18nText("FS-System-Config_SMS_Yuan"));
            var reChargeText = smsAttr.balance < 10 ? FR.i18nText("FS-System-Config_SMS_Balance_Warning") : FR.i18nText("FS-System-Config_SMS_Recharge");
            FS.SYSMGR.tabPane.getWidgetByName("rechargeLink").setValue(reChargeText);
            FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([2], !FR.isEmpty(FS.SYSMGR.username) && !smsAttr.isSMSApplied);
            FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([3, 4, 5, 6], smsAttr.isSMSApplied);
            FS.SYSMGR.tabPane.getWidgetByName("smsSetPanel").setRowVisible([2, 3, 4], smsAttr.isSMSApplied && !FR.isEmpty(FS.SYSMGR.username));
            FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([7], smsAttr.testRemain === 0);
            FS.SYSMGR.tabPane.getWidgetByName("remain").setVisible(smsAttr.testRemain !== 0);
            FS.SYSMGR.tabPane.getWidgetByName("remain-tip").setVisible(smsAttr.testRemain !== 0);

            // var publicGrid = FS.SYSMGR.tabPane.getWidgetByName("publicModel");
            // var privateGrid = FS.SYSMGR.tabPane.getWidgetByName("privateModel");
            // publicGrid.refresh(smsAttr.publicModel);
            // privateGrid.refresh(smsAttr.privateModel);
        } else {
            smsButton.setValue(smsAttr.isSMSOpen, true);
        }
    };
    /*************短信配置*************/
    smsSetModule = function () {
        FR.$defaultImport('/com/fr/fs/plugin/op/web/store/js/bridge.js', 'js');
        var self = this;
        var settingLabel = {
            type: 'llabel',
            levelStyle: 1,
            value: FR.i18nText("FS-System-Config_SMS_Setting"),
            firstStyleWidth: 880
        };
        var monitorLabel = {
            type: 'llabel',
            levelStyle: 1,
            value: FR.i18nText("FS-System-Config_SMS_Monitor"),
            firstStyleWidth: 880
        };
        var settingTablePane = {
            widgetName: 'smsSettingTablePane',
            type: 'tablepane',
            //colSize: [130, 750],
            colSize: [130, 600],
            //rowSize: [25, 25, 25, 25, 17, 25, 240, 25, 25],
            rowSize: [25, 25, 25, 25, 17, 25, 25, 25],
            vgap: 15,
            items: [
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Using_Platform")},
                    {
                        type: 'switch',
                        widgetName: 'sms',
                        onTurnOff: function () {
                            //关闭短信服务
                            //FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([1, 2, 3, 4, 5, 6, 7, 8], false);
                            FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([1, 2, 3, 4, 5, 6, 7], false);
                            FS.SYSMGR.tabPane.getWidgetByName("smsSetPanel").setRowVisible([2, 3, 4], false);
                            FS.Sync.ajax({
                                url: FR.servletURL + '?op=fs_sms&cmd=sms_config_set',
                                type: 'POST',
                                data: {
                                    serverID: FS.serverID,
                                    isSMSOpen: false
                                }
                            });
                        },
                        onTurnOn: function () {
                            if (!FS.SYSMGR.isSMSFuncSupport) {
                                FR.Msg.alert(FR.i18nText('Fine-Engine_Alert'), FR.i18nText('FS-Generic-You_Are_Using_Unregisted_Function') + ' \n ' + FR.i18nText('Fine-Engine_Func_SMS'));
                                return false;
                            }
                            //开启短信服务
                            // FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([1, 2, 3, 4, 5, 6, 7, 8], true);
                            FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([1], true);
                            var config = FS.Sync.ajax({
                                url: FR.servletURL + '?op=fs_sms&cmd=sms_config_set',
                                type: 'POST',
                                data: {
                                    serverID: FS.serverID,
                                    isSMSOpen: true
                                }
                            });
                            _popSmsData(config);
                        }
                    }
                ],
                // [
                //     {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Platform")},
                //     {
                //         type: 'radiogroup',
                //         assureSelect: true,
                //         items: [
                //             {text: FR.i18nText("FS-System-Config_SMS_Innner_Account"), value: 0},
                //             {text: FR.i18nText("FS-System-Config_SMS_Private_Account"), value: 1}
                //         ],
                //         widgetName: 'accountType',
                //         listeners: [{
                //             eventName: 'statechange',
                //             action: function () {
                //                 var value = this.getValue();
                //                 if (value === 1) {
                //                     var dialog = new FR.Dialog({
                //                         title: '',
                //                         confirm: true,
                //                         destroyOnClose: true,
                //                         resizeable: false,
                //                         width: 400,
                //                         height: 210,
                //                         contentWidget: {
                //                             type: 'absolute',
                //                             items: [
                //                                 {
                //                                     type: 'label',
                //                                     value: 'this function is developing....',//todo
                //                                     x: 50,
                //                                     y: 70,
                //                                     width: 100,
                //                                     height: 21
                //                                 }
                //                             ]
                //                         }
                //                     });
                //                     dialog.setVisible(true);
                //                 }
                //             }
                //         }]
                //     }
                // ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Accout_Bind")},
                    {
                        type: 'quickbutton',
                        widgetName: 'sms_username',
                        style: 'blue',
                        width: 92,
                        text: FR.i18nText("Fine-Engine_Plugin_Store_Not_Login"),
                        handler: function () {
                            if (FS.SYSMGR.username) {
                                _createTriggerView();
                                return;
                            }
                            _createLoginDialog();
                        }
                    }
                ],
                [
                    $('<div/>'),
                    {
                        type: 'quickbutton',
                        widgetName: 'smsApplyBtn',
                        style: 'blue',
                        width: FR.i18nTextWidth("FS-SMS_Service_Apply", 7),
                        text: FR.i18nText("FS-SMS_Service_Apply"),
                        handler: function () {
                            var url = FS.Trans.ajax({
                                url: FR.servletURL + '?op=fs_set&cmd=site_center_helper',
                                returnString: true,
                                data: {
                                    key: 'sms_apply_link'
                                }
                            });
                            window.open(url);
                        }
                    }

                ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Balance")},
                    _createBalanceDiv()

                ],
                [
                    $('<div/>'),
                    {
                        type: 'label',
                        value: FR.i18nText("FS-System-Config_SMS_Fee_Tip"),
                        cls: 'fs-servercfg-text-fee'
                    }

                ],

                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Signature")},
                    {
                        type: 'llabel',
                        widgetName: 'signature'
                    }
                ],
                // [
                //     {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Model"), height: 17},
                //     _createModelPane()
                // ],
                // [
                //     $('<div/>'),
                //     {
                //         type: 'quickbutton',
                //         style: 'blue',
                //         width: 80,
                //         text: FR.i18nText("FS-System-Config_SMS_Model_Mangement"),
                //         handler: function () {
                //
                //         }
                //     }
                // ],
                [
                    {type: 'llabel', value: FR.i18nText("FS-System-Config_SMS_Test")},
                    _createSMSTestDiv()
                ],
                [
                    $('<div/>'),
                    {type: 'label', value: FR.i18nText("FS-System-Config_SMS_Test_Fee_Tip")}
                ]
            ]
        };
        var mailSetPanel = {
            title: FR.i18nText("FS-Generic-Simple_SMS"),
            content: {
                widgetName: 'smsSetPanel',
                type: 'tablepane',
                colSize: [80, 900],
                //rowSize: [25, 600, 25, 25, 300],
                rowSize: [25, 230, 25, 25, 400],
                vgap: 20,
                items: [
                    [null, settingLabel],
                    [null, settingTablePane],
                    [null, monitorLabel],
                    [null, _createSMSQueryPane()],
                    [null, _createSMSDetailPane()]
                ]
            }
        };
        return mailSetPanel;
    };
    _createSMSDetailPane = function () {
        var columns = [
            {
                key: 'receiver',
                value: FR.i18nText("FS-Generic-Simple_Receiver"),
                width: 120
            },
            {
                key: 'mobile',
                value: FR.i18nText("FS-Generic-Simple_Mobile_Number"),
                width: 120
            },
            {
                key: 'content',
                value: FR.i18nText("FS-System-Config_SMS_Content"),
                width: 290
            },
            {
                key: ' ',
                value: '',
                width: 15
            },
            {
                key: 'date',
                value: FR.i18nText("Fine-Engine_Platform_RP_Send_Date"),
                width: 140
            },
            {
                key: 'result',
                value: FR.i18nText("FS-System-Config_SMS_Send_Result"),
                width: 100,
                onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                    var valKey = $.inArray(colCfg.key, this.options.localeArray) == -1 ? item[colCfg.key] : FR.i18nText(item[colCfg.key]);
                    var val = valKey ? FR.i18nText("FS-Generic-HJS_Send_Successfully") : FR.i18nText("FS-Generic-HJS_Send_Failed");
                    var $cell = $('<div class="cell"/>').width(this._calculateWidth(colCfg))
                        .text(val).attr('title', val);
                    return $cell;
                }
            },
            {
                key: 'detail',
                value: ' ',
                width: 70,
                onCellCreate: function (rowIdx, colIdx, item, colCfg) {
                    if (!item.detail) {
                        return;
                    }
                    var $cell = $('<div class="fs-sys-detail"/>')
                        .text(FR.i18nText("FS-System-Detail_Info"))
                        .hover(
                            function () {
                                $(this).addClass('fs-sys-detail-hover');
                            },
                            function () {
                                $(this).removeClass('fs-sys-detail-hover');
                            }
                        )
                        .click(function () {
                            var $tipContext = $('<div class="fs-sys-detailmsg"/>')
                                .append($('<span/>').text(item.detail));
                            $tipContext.appendTo($('body')).css({
                                position: 'absolute',
                                left: $(this).offset().left + $(this).width(),
                                top: $(this).offset().top + $(this).height(),
                                'z-index': FR.widget.opts.zIndex++
                            });
                            $(document).bind('mousedown.tip', function (e) {
                                var target = e.target;
                                if (!$(target).isChildAndSelfOf('.fs-sys-detailmsg')) {
                                    $tipContext.remove();
                                    $(document).unbind('mousedown.tip');
                                }
                            });
                        });
                    return $cell;
                }
            }
        ];
        return {
            type: 'quickgrid',
            page: true,
            autoPage: true,
            pageCount: 10,
            intervalColor: true,
            widgetName: "grid-sms",
            items: [],
            columnsConfig: columns
        };
    };
    _createSMSQueryPane = function () {
        var self = this;
        var date = new Date();
        return {
            width: 900,
            height: 25,
            widgetName: 'smsQuery',
            type: 'absolute',
            items: [
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Generic-Simple_Receiver"),
                    textalign: 'center',
                    x: 0,
                    y: 4,
                    height: 21,
                    width: 50
                },
                {
                    type: 'text',
                    x: 60,
                    y: 4,
                    height: 21,
                    width: 120,
                    widgetName: 'receiver'
                },
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-System-Config_SMS_Content"),
                    textalign: 'center',
                    x: 190,
                    y: 4,
                    height: 21,
                    width: 60
                },
                {
                    type: 'text',
                    x: 260,
                    y: 4,
                    height: 21,
                    width: 120,
                    widgetName: 'content'
                },
                {type: 'llabel', value: FR.i18nText("FS-Schedule-Start_Date"), x: 390, y: 4, height: 21, width: 15},
                {
                    type: 'datetime',
                    value: new Date(date.getTime() - 1000 * 60 * 60 * 24),
                    format: 'yyyy-MM-dd',
                    x: 415,
                    y: 4,
                    height: 21,
                    width: 120,
                    widgetName: "sms-startdate"
                },
                {
                    type: 'llabel',
                    value: FR.i18nText("FS-Schedule-End_Date"),
                    textalign: 'center',
                    x: 545,
                    y: 4,
                    height: 21,
                    width: 15
                },
                {
                    type: 'datetime',
                    value: date,
                    format: 'yyyy-MM-dd',
                    x: 570,
                    y: 4,
                    height: 21,
                    width: 120,
                    widgetName: "sms-enddate"
                },
                {
                    type: 'quickbutton',
                    style: 'blue',
                    text: FR.i18nText("FS-Generic-Simple_Query"),
                    x: 720,
                    y: 4,
                    height: 21,
                    width: 80,
                    handler: function () {
                        var startTime = FS.SYSMGR.tabPane.getWidgetByName('sms-startdate').getValue();
                        var endTime = FS.SYSMGR.tabPane.getWidgetByName('sms-enddate').getValue();
                        var receiver = FS.SYSMGR.tabPane.getWidgetByName('receiver').getValue();
                        var content = FS.SYSMGR.tabPane.getWidgetByName('content').getValue();
                        var url = FR.servletURL + '?op=fs_sms&cmd=sms_get_records';
                        var para = {
                            startTime: startTime + ' 00:00:00',      //开始时间的零时
                            endTime: endTime + ' 23:59:59',        //结束时间的24时
                            receiver: receiver,        //收件人
                            content: content          //信息内容
                        };
                        var completeFn = function (res, status) {
                            var result = FR.jsonDecode(res.responseText);
                            FS.SYSMGR.tabPane.getWidgetByName("grid-sms").refresh(result.data);
                        };
                        FS.Async.ajax({
                            url: url,
                            type: 'POST',
                            data: para
                        }, completeFn);
                    }
                }
            ]
        };
    };
    _createModelPane = function () {
        return {
            widgetName: 'smsModelPane',
            type: 'tablepane',
            colSize: [730],
            rowSize: [120, 120],
            vgap: 0,
            items: [
                [
                    this._createPublicModelTable()
                ], [
                    this._createPrivateModelTable()
                ]
            ]
        };
    };
    _createPublicModelTable = function () {
        var columns = [
            {
                key: 'content',
                value: FR.i18nText("FS-System-Config_SMS_Model_Public"),
                width: 730
            }
        ];
        return {
            type: 'quickgrid',
            page: true,
            autoPage: true,
            pageCount: 2,
            intervalColor: true,
            widgetName: "publicModel",
            items: [],
            columnsConfig: columns
        };
    };
    _createPrivateModelTable = function () {
        var columns = [
            {
                key: 'content',
                value: FR.i18nText("FS-System-Config_SMS_Model_Private"),
                width: 730
            }
        ];
        return {
            type: 'quickgrid',
            page: true,
            autoPage: true,
            pageCount: 2,
            intervalColor: true,
            widgetName: "privateModel",
            items: [],
            columnsConfig: columns
        };
    };
    _createSMSTestDiv = function () {
        var self = this;
        var testPanel = {
            type: 'panel',
            width: 600,
            doSize: true,
            contentWidget: {
                widgetName: 'testPanel',
                type: 'absolute',
                items: [
                    {
                        type: 'iconbutton',
                        x: 0,
                        y: 1,
                        width: 100,
                        height: 25,
                        text: FR.i18nText("FS-System-Config_SMS_Send_Test"),
                        baseClass: 'fs-servercfg-link',
                        handler: function () {
                            var testDialog = new FR.Dialog({
                                title: FR.i18nText('FS-System-Config_SMS_Send_Test'),
                                confirm: true,
                                destroyOnClose: true,
                                resizeable: false,
                                width: 400,
                                height: 210,
                                contentWidget: {
                                    type: 'absolute',
                                    items: [
                                        {
                                            type: 'label',
                                            value: FR.i18nText('FS-System-Config_SMS_Mobile_Receiver'),
                                            x: 130 - FR.i18nTextWidth('FS-System-Config_SMS_Mobile_Receiver', 6.5),
                                            y: 70,
                                            width: FR.i18nTextWidth('FS-System-Config_SMS_Mobile_Receiver', 6.5),
                                            height: 21,
                                            verticalcenter: true
                                        },
                                        {
                                            widgetName: 'mobile-receiver',
                                            type: 'text',
                                            regex: "^\\d{11}$",
                                            value: FR.i18nText('FS-System-Config_SMS_Mobile_Receiver'),
                                            x: 140,
                                            y: 70,
                                            width: 200,
                                            height: 21
                                        }
                                    ]
                                },
                                onOK: function () {
                                    var mobile = this.getWidgetByName("mobile-receiver").getValue();
                                    var completeFn = function (res, status) {
                                        var rs = FR.jsonDecode(res.responseText);
                                        if (rs.res_code === 'success') {
                                            FR.Msg.toast(FR.i18nText("FS-Generic-HJS_Send_Successfully"));
                                            var remain = FS.SYSMGR.tabPane.getWidgetByName('remain');
                                            remain.setValue(remain.getValue() - 1);
                                            if (remain.getValue() <= 0) {
                                                FS.SYSMGR.tabPane.getWidgetByName("smsSettingTablePane").setRowVisible([7], true);
                                                FS.SYSMGR.tabPane.getWidgetByName("remain").setVisible(false);
                                                FS.SYSMGR.tabPane.getWidgetByName("remain-tip").setVisible(false);
                                            }
                                        } else if (rs.res_code === 'failed') {
                                            var detail = rs.res_detail || FR.i18nText('FS-System-Config_SMS_Test_Failed_Tip');
                                            FR.Msg.alert(FR.i18nText('FS-System-Config_SMS_Send_Test'), FR.i18nText('FS-System-Config_SMS_Test_Failed') + ' \n ' + detail);
                                        }
                                    };
                                    var config = {
                                        url: FR.servletURL + '?op=fs_sms&cmd=sms_test',
                                        type: 'POST',
                                        data: {
                                            mobile: mobile
                                        }
                                    };
                                    FS.Async.ajax(config, completeFn);
                                }
                            });
                            testDialog.setVisible(true);
                        }
                    },
                    {
                        widgetName: 'remain-tip',
                        type: 'label',
                        x: 110,
                        y: 1,
                        width: FR.i18nTextWidth('FS-System-Config_SMS_Test_Remain', 6.5),
                        cls: 'fs-servercfg-text-tip',
                        value: FR.i18nText("FS-System-Config_SMS_Test_Remain")
                    },
                    {
                        widgetName: 'remain',
                        type: 'label',
                        x: 110 + FR.i18nTextWidth('FS-System-Config_SMS_Test_Remain', 6.5),
                        y: 1,
                        width: 10,
                        cls: 'fs-servercfg-text-remain'
                    }
                ]
            }
        }
        return testPanel;
    };
    _createBalanceDiv = function () {
        var balancePanel = {
            type: 'panel',
            width: 600,
            doSize: true,
            contentWidget: {
                widgetName: 'balancePanel',
                type: 'absolute',
                items: [
                    {
                        widgetName: 'balance',
                        type: 'label',
                        x: 0,
                        y: 1,
                        width: 75,
                        cls: 'fs-servercfg-text-normal'

                    },
                    {
                        widgetName: 'rechargeLink',
                        x: 75,
                        y: 1,
                        width: FR.i18nText("FS-System-Config_SMS_Recharge", 6.5),
                        height: 25,
                        type: 'iconbutton',
                        text: FR.i18nText("FS-System-Config_SMS_Recharge"),
                        baseClass: 'fs-servercfg-test',
                        handler: function () {
                            var url = FS.Trans.ajax({
                                url: FR.servletURL + '?op=fs_set&cmd=site_center_helper',
                                returnString: true,
                                data: {
                                    key: 'sms_recharge_link'
                                }
                            });
                            window.open(url);
                        }
                    }
                ]
            }
        }
        return balancePanel;
    };
    _createLoginDialog = function () {
        var href = FS.Sync.ajax({url: FR.servletURL + '?op=plugin&cmd=site'});
        var loginDialog = new FR.Dialog({
            title: FR.i18nText("Fine-Engine_Plugin_Store_BBS_Account_Login"),
            destroyOnClose: true,
            resizeable: false,
            width: 400,
            height: 300,
            contentWidget: {
                type: 'tablepane',
                width: 320,
                height: 260,
                items: [
                    [
                        {
                            type: 'text',
                            widgetName: 'account_store',
                            watermark: FR.i18nText('Fine-Engine_Report_Store_Pass'),
                            fontSize: 14
                        }
                    ],

                    [
                        {
                            type: 'password',
                            widgetName: 'pwd_store',
                            watermark: FR.i18nText('Fine-Engine_Plugin_Store_Password'),
                            fontSize: 14

                        }
                    ],
                    [
                        {

                            type: 'label',
                            widgetName: 'error_tip',
                            value: '',
                            color: "#337ab7",
                            verticalcenter: true,
                            fontsize: 13
                        }
                    ],
                    [{
                        type: 'quickbutton',
                        text: FR.i18nText("Fine-Engine_Plugin_Store_Login"),
                        style: 'blue',
                        fontsize: 14,
                        handler: function () {
                            var username = loginDialog.getWidgetByName("account_store").getValue();
                            var password = loginDialog.getWidgetByName("pwd_store").getValue();
                            var errorLabel = loginDialog.getWidgetByName("error_tip");
                            if (FR.isEmpty(username) || FR.isEmpty(password)) {
                                errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_Not_Null"));
                            }
                            FS.Tools.bbsDefaultLogin(username, password, function (result) {
                                var decodeResult = FR.jsonDecode(result);
                                var loginTag = decodeResult[0].loginTag;
                                var uid = decodeResult[0].uid;
                                loginTag = parseInt(loginTag, 10);
                                if (loginTag === 0) {
                                    FS.SYSMGR.username = decodeResult[0].username || username;
                                    FS.SYSMGR.tabPane.getWidgetByName('sms_username').setValue(FS.SYSMGR.username, false);
                                    errorLabel.setValue("");
                                    loginDialog.doClose();
                                    _popSmsData();
                                    FS.Tools.bbsUcsynLogin(uid, FS.SYSMGR.username, password, function (result) {
                                        $('.sync-log').remove();
                                        $('body').append('<div class="sync-log">' + result + '</div>');
                                    });
                                }
                                if (loginTag === -1) {
                                    errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_User_Not_Exist"));
                                }
                                if (loginTag === -2) {
                                    errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_User_Password_Error"));
                                }
                                if (loginTag === -3) {
                                    errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_Unexpected_Error"));
                                }
                                if (loginTag === -4) {
                                    errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_Net_Connect_Failed"));
                                }
                                if (loginTag === -5) {
                                    errorLabel.setValue(FR.i18nText("Fine-Engine_Plugin_Store_Not_Null"));
                                }
                            });
                        }
                    }],
                    [_createLoginFoot()]
                ],
                colSize: [320],
                rowSize: [40, 40, 'auto', 40, 24],
                vgap: 15
            }
        });
        loginDialog.setVisible(true);
        var justBeautyDialog = function () {
            $('.fr-core-window-header').css('background', 'white');
            $('.fr-core-panel-title').addClass('fs-login-dialog-title');
            $('.fr-core-window').css({
                'border-radius': 0,
                'border': 'solid 1px #009DE3'
            });
            $('.fr-core-panel-body').css('padding', '40px 40px 20px 40px');
            $('.fr-core-panel-body-border').css('border', 'none');
        };
        justBeautyDialog();
    };
    _createLoginFoot = function () {
        return {
            renderEl: $('<div class="fs-pass-login-foot"/>'),
            type: 'absolute',
            items: [
                {
                    el: {
                        type: 'label',
                        value: FR.i18nText('Fine-Engine_Plugin_Store_No_Account_Tip'),
                        color: '#878A8E',
                        verticalcenter: true,
                        fontsize: 12
                    }
                },
                {
                    el: {
                        type: 'iconbutton',
                        text: FR.i18nText('FS-Reg-Immediately'),
                        baseClass: 'fs-pass-link',
                        width: 80,
                        handler: function () {
                            window.open("http://id.fanruan.com/register/register.php?clueSource=activityfr");
                        }
                    },
                    x: FR.i18nTextWidth('Fine-Engine_Plugin_Store_No_Account_Tip', 6)
                },
                {
                    el: {
                        type: 'iconbutton',
                        text: FR.i18nText('Fine-Engine_Plugin_Store_Forgot_Password') + '?',
                        baseClass: 'fs-pass-link',
                        width: FR.i18nTextWidth('Fine-Engine_Plugin_Store_Forgot_Password', 7),
                        handler: function () {
                            window.open("http://id.fanruan.com/forget/forget.php?clue=activityf");
                        }
                    },
                    x: 320 - FR.i18nTextWidth('Fine-Engine_Plugin_Store_Forgot_Password', 7)
                }
            ]
        };

    };
    _createTriggerView = function () {
        var $view = $('<div class="fs-login-trigger"/>');
        var btnWrap = FR.createWidget({
            type: 'absolute',
            items: [
                {
                    type: 'quickbutton',
                    text: FR.i18nText("Fine-Engine_Plugin_Store_Private_Message"),
                    height: 25,
                    width: 70,
                    style: 'blue',
                    handler: function () {
                        $view.remove();
                        FS.Tools.getBBsPrivateMessage();//私人消息
                    },
                    x: 10,
                    y: 10
                },
                {
                    type: 'quickbutton',
                    text: FR.i18nText("Fine-Engine_Plugin_Store_Switch_Account"),
                    height: 25,
                    width: 70,
                    style: 'blue',
                    handler: function () {
                        $view.remove();
                        _createLoginDialog();
                    },
                    x: 10,
                    y: 45
                }
            ]
        });
        $view.append(btnWrap.element);
        _modifyPosition($view);
        $view.appendTo('body');
        $(document).bind('mousedown.tip', function (e) {
            var target = e.target;
            if (!$(target).isChildAndSelfOf('.fs-login-trigger')) {
                $view.remove();
                $(document).unbind('mousedown.tip');
            }
        });
    };
    _createQQLoginDiv = function () {
        if ($('.qqLoginIframe').length > 0) {
            $('.qqLoginIframe').css('display', 'block');
            $('.iframe-qq-login').attr('src', "https://graph.qq.com/oauth/show?which=ConfirmPage&display=pc&response_type=code&client_id=101332435&redirect_uri=http://login.fanruan.com/qq_login.php" + '&a=' + Math.random());
            return;
        }
        var $view = $('<div class="qqLoginIframe"/>');
        var divWrap = FR.createWidget({
            type: 'absolute',
            items: [
                {
                    el: $('<div class="qq-dialog-close"/>')
                },
                {
                    el: $('<iframe class="iframe-qq-login" frameborder=0 width=700 height=450 marginheight=0 marginwidth=0 scrolling=no/>')
                }
            ]
        });
        $view.append(divWrap.element);
        $view.appendTo(FS.SYSMGR.tabPane.element);
        $('.iframe-qq-login').attr('src', "https://graph.qq.com/oauth/show?which=ConfirmPage&display=pc&response_type=code&client_id=101332435&redirect_uri=http://login.fanruan.com/qq_login.php" + '&a=' + Math.random());
        $('.qq-dialog-close').click(function () {
            $('.qqLoginIframe').css('display', 'none');
        });
    };
    _create404Div = function () {
        var $view = $('<div class="fs-connect-error"/>');
        var divWrap = FR.createWidget({
            type: 'absolute',
            items: [
                {
                    el: $('<div class="fs-connect-error-404"/>')
                },
                {
                    type: 'label',
                    value: FR.i18nText("FS-Plugin-Store_Disconnected"),
                    height: 25,
                    width: 440,
                    textalign: 'center',
                    x: 0,
                    y: 250
                }
            ]
        });
        $view.append(divWrap.element);
        _modifyPosition($view, true, 40);
        $view.appendTo(FS.SYSMGR.tabPane.element);
    };
    _modifyPosition = function ($view, isRelative, relativeLeft) {
        var btn = FS.SYSMGR.tabPane.getWidgetByName('sms_username');
        var invalid = btn.options.offset != null && btn.element.offset().top === 0 && btn.element.offset().left === 0;
        var eH = Math.max(parseInt(invalid ? btn.options.offset.top : btn.element.offset().top), 0);
        var eL = Math.max(parseInt(invalid ? btn.options.offset.left : btn.element.offset().left), 0);
        var wH = parseInt(btn.options.height);
        var wL = parseInt(btn.options.width);
        var tH = $view.height();
        var tW = $view.width();

        var bottomHeight = document.body.clientHeight - eH - wH;
        /*b:判断的依据应该是editcomp上下部的高度对比*/
        if (eH < bottomHeight || eH < tH) {
            $view.css('top', eH + wH + (FR.Browser.r.gecko ? 1 : 0));
            if (bottomHeight < tH) {
                _modifyTop(eH, $view, tH);
            }
        } else {
            _modifyTop(eH, $view, tH);
        }
        if (isRelative) {
            $view.css('left', relativeLeft);
        } else {
            if (eL + tW > document.body.clientWidth && (eL + wL > tW)) {
                $view.css('left', eL + wL - $view.width());
            } else {
                $view.css('left', eL);
            }
        }
    };

    _modifyTop = function (eH, $view, tH) {
        $view.css('top', (eH - tH > 0) ? eH - tH : 0);
    };

    FS.Plugin.SystemItems.push({
        tabIndex: 3,
        ui: this.smsSetModule,
        popAction: this._popSmsData
    });
})(jQuery);