/**
 * Coder: Sean
 * Date: 13-11-6
 * Time: 上午12:02
 */
FS.PASSWORD = {
    init: function (renderer) {
        var items = [FS.userInfoModule()];
        this.infoChange = new FS.LTabPane({
            width: '100%',
            height: '100%',
            items: items,
            style: 'blue',
            renderEl: renderer,
            marginLeft: 40
        });
        var infoChange = this.infoChange;
        $.ajax({
            url: FR.servletURL + "?op=fs_main&cmd=user_getinfo",
            cache: false,
            async: false,
            success: function (res, status) {
                if (status === 'success') {
                    var user = FR.jsonDecode(res);
                    if (user.email) {
                        infoChange.getWidgetByName("emailText").setValue(null);
                        infoChange.getWidgetByName("emailTextLabel").setValue(user.email);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([6], false);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([7], true);
                    } else {
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([6], true);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([7], false);
                    }
                    if (user.mobile) {
                        infoChange.getWidgetByName("phoneText").setValue(null);
                        infoChange.getWidgetByName("phoneTextLabel").setValue(user.mobile);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([11], false);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([12], true);
                    } else {
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([11], true);
                        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([12], false);
                    }
                    infoChange.getWidgetByName("usernameTextLabel").setValue(user.username);
                    infoChange.getWidgetByName("usernameText").setValue(null);
                    infoChange.getWidgetByName("fullnameTextLabel").setValue(user.realname);
                    infoChange.getWidgetByName("fullnameText").setValue(null);
                    infoChange.getWidgetByName('userInfoTablelayout').doLayout();
                }
            }
        });
        if (FS.isAdmin()) {
            infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([3], false);
        } else {
            $('[widgetName=editusername]').remove();
        }
        infoChange.getWidgetByName('userInfoTablelayout').setRowVisible([1, 2, 4, 5, 8, 9, 10, 13, 14, 15, 17, 18, 19, 20], false);
        infoChange.getWidgetByName('userInfoTablelayout').doLayout();
        $("input[name='usernameText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Username'));
        $("input[name='fullnameText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Realname'));
        $("input[name='emailText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Email'));
        $("input[name='phoneText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Phone'));
        $("input[name='oldPwdText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Old_Pwd'));
        $("input[name='newPwdText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_New_Pwd'));
        $("input[name='verifyPwdText']").attr("placeholder", FR.i18nText('FS-System-Please_Input_Confirm_Pwd'));
        $("input[name='emailCode']").attr("placeholder", FR.i18nText('FS-System-Please_Input_VerificationCode'));
        $("input[name='phoneCode']").attr("placeholder", FR.i18nText('FS-System-Please_Input_VerificationCode'));
    }
};