/**
 * Created by kerry on 2017/7/13.
 */
(function () {

    FS.Plugin.MessageHelper.items.push({
        version: 1.0,
        action: function (msg) {
            if (FR.isEmpty(msg) || FR.isEmpty(msg.url)) {
                return;
            }
            var hasDeal = false;
            //处理一些消息的其他操作
            $.each(FS.Plugin.SystemMsgActionProvider.items, function (i, item) {
                if (FR.Plugin.validLevel(FS.Plugin.SystemMsgActionProvider, item) && item.url === msg.url && !hasDeal) {
                    hasDeal = true;
                    item.action.call(self, msg);
                }
            });
            if (msg.type === "system_message" && !hasDeal) {
                var url = msg.url.startWith("ReportServer") ? FR.server + "/" + FR.cjkEncode(msg.url) : FR.cjkEncode(msg.url);
                FS.tabPane.addItem({
                    title: msg.title,
                    id: "message" + msg.id,
                    src: url
                });
            }
        }
    });

    FS.Plugin.SystemMessageProvider.items.push({
        version: 1.0,
        action: function (index) {
            var config = {
                title: FR.i18nText("FS-Generic-RP_System_Message"),
                messageType: ["system_message"]
            };
            return this.createMsgPaneConfig(index, config);
        }
    });
})();