$(function() {
	var $reportPane = $("<div class='reportPane'></div>");
	window.contentPane = $reportPane.asComponent(${panel_config});
	
	FR.SessionMgr.register('${sessionID}', contentPane);
	${widgetCss};
	contentPane.on("init", function() {
		var regions = [{region:'center', el:$reportPane}];
        var $container = $("body").asComponent({
            type: "border", items: regions,
            width: Math.max(FR.windowWidth, 100),
            height: Math.max(FR.windowHeight, 100)
        });
		$container.doLayout();
        $container.element.css({
            width: '100%',
            height: '100%'
        });
		$(window).resize(function() {
			$container.doLayout();
		})
	});
	
	(function() {
		${loading}
    }).apply(contentPane);
});